local i=require"nixio.fs"
local e=require"luci.sys"
local a=require"luci.http"
local t=require("luci.model.uci").cursor()
if i.access("/usr/share/coredns/coredns")then
coredns_version=e.exec("/usr/share/coredns/coredns -version")
coredns_plugins=e.exec("/usr/share/coredns/coredns -plugins")
else
coredns_version=translate("Unknown Version, Pleaes upload a valid CoreDNS program.")
coredns_plugins=translate("Cannot get plugins list, please check if coredns program was uploaded correctly")
end
ful=SimpleForm("coredns",'CoreDNS',coredns_version)
ful.reset=false
ful.submit=false
sul=ful:section(SimpleSection,translate("Upload"))
o=sul:option(FileUpload,"")
o.template="coredns/upload"
um=sul:option(DummyValue,"",nil)
um.template="coredns/dvalue"
local t,e,n
t="/usr/share/coredns/"
tmp_dir="/tmp/coredns/bin/"
os.execute(string.format("rm -rf %s >/dev/null 2>&1",tmp_dir))
os.execute(string.format("mkdir -p %s >/dev/null 2>&1",tmp_dir))
a.setfilehandler(
function(t,a,o)
if not e then
if not t then return end
e=nixio.open(tmp_dir..t.file,"w")
if not e then
um.value=translate("Create upload file error")
return
end
end
if a and e then
e:write(a)
end
if o and e then
e:close()
e=nil
if string.lower(string.sub(t.file,-7,-1))==".tar.gz"then
os.execute(string.format("tar -C '/tmp/coredns' -xzf %s >/dev/null 2>&1",(tmp_dir..t.file)))
i.unlink(tmp_dir..t.file)
os.execute(string.format("mv $(echo \"/tmp/coredns/bin/$(ls /tmp/coredns/bin/)\") '/usr/share/coredns/coredns' >/dev/null 2>&1"))
elseif string.lower(string.sub(t.file,-3,-1))==".gz"then
os.execute(string.format("mv %s '/tmp/coredns/bin/coredns.gz' >/dev/null 2>&1",(tmp_dir..t.file)))
os.execute("gzip -fd '/tmp/coredns/bin/coredns.gz' >/dev/null 2>&1")
i.unlink("/tmp/coredns/bin/coredns.gz")
else
os.execute(string.format("mv $(echo \"/tmp/coredns/bin/$(ls /tmp/coredns/bin/)\") '/usr/share/coredns/coredns' >/dev/null 2>&1"))
end
os.execute("chmod 4755 /usr/share/coredns/coredns >/dev/null 2>&1")
os.execute(string.format("rm -rf %s >/dev/null 2>&1",tmp_dir))
um.value=translate("Please refresh this page, the upload file has already been saved to")..' "/usr/share/coredns/coredns"'
end
end
)
if a.formvalue("upload")then
local e=a.formvalue("ulfile")
if#e<=0 then
um.value=translate("No Specify Upload File")
end
end
s=ful:section(SimpleSection,translate("Plugins"))
o=s:option(TextValue,"","")
o.default=coredns_plugins
o.readonly=true
return ful
